1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277
|
#!/bin/bash
#
# Copyright (C) 2018 Nikos Mavrogiannopoulos
#
# This file is part of ocserv.
#
# ocserv is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# ocserv is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
# This tests operation/traffic under compression (lzs or lz4).
PKG_CONFIG="${PKG_CONFIG:-/usr/bin/pkg-config}"
OCCTL="${OCCTL:-../src/occtl/occtl}"
SERV="${SERV:-../src/ocserv}"
srcdir=${srcdir:-.}
PIDFILE=ocserv-pid.$$.tmp
CLIPID=oc-pid.$$.tmp
PATH=${PATH}:/usr/sbin
IP=$(which ip)
OUTFILE=traffic.$$.tmp
RADIUSLOG=radius-otp.$$.log
RADIUSD=$(which radiusd)
if test -z "${RADIUSD}";then
RADIUSD=$(which freeradius)
fi
. `dirname $0`/common.sh
eval "${GETPORT}"
if test -z "${IP}";then
echo "no IP tool is present"
exit 77
fi
if test -z "${RADIUSD}";then
echo "no radiusd is present"
exit 77
fi
if test "$(id -u)" != "0";then
echo "This test must be run as root"
exit 77
fi
${PKG_CONFIG} --atleast-version=1.2.7 radcli
if test $? != 0;then
echo "radcli version less than 1.2.7 does not support Access-Challenge server response"
exit 77
fi
echo "Testing ocserv and radius (otp authentication)... "
function finish {
set +e
echo " * Cleaning up..."
test -n "${PID}" && kill ${PID} >/dev/null 2>&1
test -n "${RADIUSPID}" && kill ${RADIUSPID} >/dev/null 2>&1
test -n "${PIDFILE}" && rm -f ${PIDFILE} >/dev/null 2>&1
test -f "${CLIPID}" && kill $(cat ${CLIPID}) >/dev/null 2>&1
test -n "${CLIPID}" && rm -f ${CLIPID} >/dev/null 2>&1
test -n "${CONFIG}" && rm -f ${CONFIG} >/dev/null 2>&1
rm -f ${OUTFILE} 2>&1
test -f "${RADIUSLOG}" && cat "${RADIUSLOG}"
rm -f "${RADIUSLOG}"
}
trap finish EXIT
# server address
. `dirname $0`/random-net.sh
# These must match the data/raddb/users:test-class user
VPNNET=192.168.55.0/24
VPNADDR=192.168.55.1
VPNNET6=fc7d:b139:f7ba:5f53:c634:e98e:b777:0/112
VPNADDR6=fc7d:b139:f7ba:5f53:c634:e98e:b777:1
OCCTL_SOCKET=./occtl-radius-otp-$$.socket
. `dirname $0`/ns.sh
${CMDNS2} ${IP} link set dev lo up
# Run servers
${CMDNS2} ${RADIUSD} -d ${srcdir}/data/raddb/ -s -xx -l ${RADIUSLOG} &
RADIUSPID=$!
update_config radius-otp.config
if test "$VERBOSE" = 1;then
DEBUG="-d 3"
fi
${CMDNS2} ${SERV} -p ${PIDFILE} -f -c ${CONFIG} ${DEBUG} & PID=$!
sleep 4
echo " * Connecting with correct password and OTP..."
USERNAME=test1-otp
( { echo "$USERNAME-stage"
for (( COUNT=1; COUNT <= 3; COUNT++ )); do
sleep 0.5
echo "$USERNAME-stage$COUNT"
done
} | ${CMDNS1} ${OPENCONNECT} ${ADDRESS}:${PORT} -u ${USERNAME} --servercert=pin-sha256:xp3scfzy3rOQsv9NcOve/8YVVv+pHr4qNCXEXrNl5s8= -s ${srcdir}/scripts/vpnc-script --pid-file=${CLIPID} -b >/dev/null 2>&1)
if test $? != 0; then
echo "Could not connect to server"
exit 1
fi
test "$VERBOSE" = 1 && ${OCCTL} -s ${OCCTL_SOCKET} show user ${USERNAME}
test "$VERBOSE" = 1 && ${OCCTL} -s ${OCCTL_SOCKET} show ip ban points
${OCCTL} -s ${OCCTL_SOCKET} unban ip ${CLI_ADDRESS} >/dev/null 2>&1
sleep 3
${CMDNS1} ${IP} addr show|grep $(echo ${VPNADDR}|cut -d '.' -f 1-3)
if test $? != 0; then
${CMDNS1} ${IP} addr show
echo "Did not find expected IP in VPN"
exit 1
fi
${CMDNS1} ping -w 3 ${VPNADDR}
if test $? != 0; then
echo "Could not ping server VPN IP"
exit 1
fi
test -f "${CLIPID}" && kill $(cat ${CLIPID}) >/dev/null 2>&1
test -n "${CLIPID}" && rm -f ${CLIPID} >/dev/null 2>&1
sleep 3
echo " * Connecting with wrong username"
# Since MAX_PASSWORD_TRIES = 3, we try 3 attempts. In the ban system, it will accumulate 30 ban-points,
# which corresponds to the maximum value of ban-points by default. To distinguish the cause of access
# denial, option "max-ban-score = 40" explicitly set in the used configuration.
USERNAME=test0-otp
( {
for (( COUNT=1; COUNT <= 3; COUNT++ )); do
sleep 0.5
echo "$USERNAME-stage"
done
} | ${CMDNS1} ${OPENCONNECT} ${ADDRESS}:${PORT} -u ${USERNAME} --servercert=pin-sha256:xp3scfzy3rOQsv9NcOve/8YVVv+pHr4qNCXEXrNl5s8= -s ${srcdir}/scripts/vpnc-script --pid-file=${CLIPID} -b --cookieonly >/dev/null 2>&1)
if test $? == 0; then
echo "Connected with wrong username"
exit 1
fi
test "$VERBOSE" = 1 && ${OCCTL} -s ${OCCTL_SOCKET} show ip ban points
${OCCTL} -s ${OCCTL_SOCKET} unban ip ${CLI_ADDRESS} >/dev/null 2>&1
sleep 3
echo " * Connecting with wrong OTP"
USERNAME=test1-otp
( { echo "$USERNAME-stage"
for (( COUNT=1; COUNT <= 3; COUNT++ )); do
sleep 0.5
if [ $COUNT -eq 2 ]; then
echo "$USERNAME-stage5"
else
echo "$USERNAME-stage$COUNT"
fi
done
} | ${CMDNS1} ${OPENCONNECT} ${ADDRESS}:${PORT} -u ${USERNAME} --servercert=pin-sha256:xp3scfzy3rOQsv9NcOve/8YVVv+pHr4qNCXEXrNl5s8= -s ${srcdir}/scripts/vpnc-script --pid-file=${CLIPID} -b --cookieonly >/dev/null 2>&1)
if test $? == 0; then
echo "Connected with wrong OTP"
exit 1
fi
${OCCTL} -s ${OCCTL_SOCKET} unban ip ${CLI_ADDRESS} >/dev/null 2>&1
sleep 3
echo " * Connecting with empty password and wrong OTP... "
# Since MAX_PASSWORD_TRIES = 3, we only make the first attempt with a blank password, and enter the wrong OTP on third stage
USERNAME=test1-otp
( { echo ""
sleep 2
echo "$USERNAME-stage"
for (( COUNT=1; COUNT <= 3; COUNT++ )); do
sleep 0.5
if [ $COUNT -eq 3 ]; then
echo "$USERNAME-stage5"
else
echo "$USERNAME-stage$COUNT"
fi
done
} | ${CMDNS1} ${OPENCONNECT} ${ADDRESS}:${PORT} -u ${USERNAME} --servercert=pin-sha256:xp3scfzy3rOQsv9NcOve/8YVVv+pHr4qNCXEXrNl5s8= -s ${srcdir}/scripts/vpnc-script --pid-file=${CLIPID} -b --cookieonly >/dev/null 2>&1)
if test $? == 0; then
echo "Connected with wrong OTP"
exit 1
fi
${OCCTL} -s ${OCCTL_SOCKET} unban ip ${CLI_ADDRESS} >/dev/null 2>&1
sleep 3
echo " * Connecting with blank OTP... "
USERNAME=test1-otp
( { echo "$USERNAME-stage"
for (( COUNT=1; COUNT <= 3; COUNT++ )); do
sleep 0.5
if [ $COUNT -eq 3 ]; then
echo -e "\n"
else
echo "$USERNAME-stage$COUNT"
fi
done
} | ${CMDNS1} ${OPENCONNECT} ${ADDRESS}:${PORT} -u ${USERNAME} --servercert=pin-sha256:xp3scfzy3rOQsv9NcOve/8YVVv+pHr4qNCXEXrNl5s8= -s ${srcdir}/scripts/vpnc-script --pid-file=${CLIPID} -b --cookieonly >/dev/null 2>&1)
if test $? == 0; then
echo "Connected with blank OTP"
exit 1
fi
${OCCTL} -s ${OCCTL_SOCKET} unban ip ${CLI_ADDRESS} >/dev/null 2>&1
sleep 3
echo " * Connecting with wrong OTP; check banning with same stage password retries"
# Ban-points are summarized - for the wrong password and wrong OTP.
# For clarity, we send a wrong password and three wrong OTP - a total of 40 ban-points,
# which corresponds to the option "max-ban-score = 40" in the used configuration.
USERNAME=test3-otp
RETRY=0
( { echo ""
sleep 2
echo "$USERNAME-stage"
for (( COUNT=1; COUNT <= 3; COUNT++ )); do
sleep 0.5
if [ $COUNT -eq 2 ] && [ $RETRY -lt 3 ]; then
echo "$USERNAME-stage5"
(( COUNT-- ))
(( RETRY++ ))
else
echo "$USERNAME-stage$COUNT"
fi
done
} | ${CMDNS1} ${OPENCONNECT} ${ADDRESS}:${PORT} -u ${USERNAME} --servercert=pin-sha256:xp3scfzy3rOQsv9NcOve/8YVVv+pHr4qNCXEXrNl5s8= -s ${srcdir}/scripts/vpnc-script --pid-file=${CLIPID} -b --cookieonly >/dev/null 2>&1)
if test $? == 0; then
echo "Successful connection with the number of OTP retries greater than allowed by the ban system (default 30)."
${OCCTL} -s ${OCCTL_SOCKET} show ip ban points
exit 1
fi
test "$VERBOSE" = 1 && ${OCCTL} -s ${OCCTL_SOCKET} show ip ban points
${OCCTL} -s ${OCCTL_SOCKET} unban ip ${CLI_ADDRESS} >/dev/null 2>&1
sleep 3
echo " * Check MAX_CHALLENGES=16 hard limit for password requests"
USERNAME=test2-otp
( { echo "${USERNAME}-stage"
for (( COUNT=1; COUNT <= 17; COUNT++ )); do
sleep 0.5
echo "$USERNAME-stage$COUNT"
done
} | ${CMDNS1} ${OPENCONNECT} ${ADDRESS}:${PORT} -u ${USERNAME} --servercert=pin-sha256:xp3scfzy3rOQsv9NcOve/8YVVv+pHr4qNCXEXrNl5s8= -s ${srcdir}/scripts/vpnc-script --pid-file=${CLIPID} -b --cookieonly >/dev/null 2>&1)
if test $? == 0; then
echo "Connected to server - MAX_CHALLENGES test failed"
exit 1
fi
sleep 3
exit 0
|